class Labirinto { //<>//

  int w = 15, h = 15;
  int[][] maze;
  float modulo;
  float subModulo;

  Labirinto(int largura, int altura) {
    w = largura; 
    h = altura;
    maze = new int[w][h];
    gerar();
  }

  void gerar() {
    modulo = (width/(w+2));
    subModulo = (width-(modulo*2))/w;
    zerar();
    maze[0][0] = 1;
    passo(0, 0);
    analise();
  }

  void zerar() {
    for (int i = 0; i < w; i++) {
      for (int j = 0; j < h; j++) { 
        maze[i][j] = 0;
      }
    }
  }

  void passo(int x, int y) {

    IntList ordem = new IntList();
    ordem.append(0); 
    ordem.append(1); 
    ordem.append(2); 
    ordem.append(3);
    ordem.shuffle();
    int indice = 0;

    for (indice = 0; indice < 4; indice++) {
      switch(ordem.get(indice)) {
      case 0: 
        {
          if (x+2 < w) {
            if (maze[x+2][y] != 1) {
              maze[x+1][y] = 1;
              maze[x+2][y] = 1;
              passo(x+2, y);
            }
          }
          break;
        }
      case 1: 
        {
          if (x-2 >= 0) {
            if (maze[x-2][y] != 1) {
              maze[x-1][y] = 1;
              maze[x-2][y] = 1;
              passo(x-2, y);
            }
          }
          break;
        }
      case 2: 
        {
          if (y+2 < h) {
            if (maze[x][y+2] != 1) {
              maze[x][y+1] = 1;
              maze[x][y+2] = 1;
              passo(x, y+2);
            }
          }
          break;
        }
      case 3: 
        {
          if (y-2 >= 0) {
            if (maze[x][y-2] != 1) {
              maze[x][y-1] = 1;
              maze[x][y-2] = 1;
              passo(x, y-2);
            }
          }
          break;
        }
      }
    }
  }

  void analise() {
    for (int i = 0; i < w; i++) {
      for (int j = 0; j < h; j++) {
        int teste = 0;
        if (maze[i][j] != 0) { 
          if (i+1 < w)  { if (maze[i+1][j] > 0) { teste += 1; } }
          if (i-1 >= 0) { if (maze[i-1][j] > 0) { teste += 1; } }
          if (j-1 >= 0) { if (maze[i][j-1] > 0) { teste += 1; } }
          if (j+1 < w)  { if (maze[i][j+1] > 0) { teste += 1; } }
          maze[i][j] = teste;
        }
      }
    }
  }

  void desenhar() {
    clear();
    background(200);    
    noStroke();
    // 0 - Parede Branco... 1 - Caminho Preto
    for (int i = 0; i < w; i++) {
      for (int j = 0; j < h; j++) {
        if (maze[i][j] == 0) { fill(0);      }
        if (maze[i][j] == 1) { fill(255);      }
        if (maze[i][j] == 2) { fill(0,200,0);  }
        if (maze[i][j] == 3) { fill(0,200,200);}
        if (maze[i][j] == 4) { fill(0,0,200);  }
        rect(modulo+(i*subModulo), modulo+(j*subModulo), subModulo, subModulo);
      }
    }
  }
}